<?php

if (!defined('_PS_VERSION_')) {
    exit;
}

class Dntradeapi extends Module {

    public function __construct() {
	$this->name = 'dntradeapi';
	$this->tab = 'administration';
	$this->version = '1.0.0';
	$this->author = 'DNTrade LTD';
	$this->need_instance = 0;

	$this->bootstrap = true;
	parent::__construct();

	$this->displayName = $this->l('DNTrade API');
	$this->description = $this->l('Модуль для обміну даними із хмарною програмою обліку DNTrade.');
    }

    public function install() {
	if (!parent::install()) {
	    return false;
	}
	return true;
    }

    public function uninstall() {
	if (!parent::uninstall()) {
	    return false;
	}
	return true;
    }

    public function getContent() {
	$output = '';

	if (Tools::isSubmit('submitToken')) {
	    $token = $this->generateToken();
	    Configuration::updateValue('DNTRADE_API_TOKEN', $token);
	    $output .= $this->displayConfirmation($this->l('Новий токен згенеровано та збережено'));
	}

	$output .= $this->displayForm();

	return $output;
    }

    public function displayForm() {
	$fields_form = [];
	$fields_form[0]['form'] = array(
	    'legend' => array(
		'title' => $this->l('Налаштування DNTrade API'),
		'icon' => 'icon-cogs',
	    ),
	    'input' => array(
		array(
		    'type' => 'textarea',
		    'label' => $this->l('API Токен'),
		    'name' => 'api_token',
		    'cols' => 60,
		    'rows' => 5,
		    'desc' => $this->l('Згенерований API токен.'),
		    'readonly' => true
		),
	    ),
	    'submit' => array(
		'title' => $this->l('Згенерувати токен'),
		'class' => 'btn btn-default pull-right',
		'name' => 'submitToken',
		'icon' => 'icon-refresh',
	    ),
	);

	$helper = new HelperForm();
	$helper->module = $this;
	$helper->show_toolbar = false;
	$helper->table = $this->table;
	$lang = new Language((int) Configuration::get('PS_LANG_DEFAULT'));
	$helper->default_form_language = $lang->id;
	$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG', 0);
	$helper->identifier = $this->identifier;
	$helper->submit_action = 'submitToken';
	$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false)
		. '&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name;
	$helper->token = Tools::getAdminTokenLite('AdminModules');
	$helper->tpl_vars = array(
	    'fields_value' => array(
		'api_token' => Configuration::get('DNTRADE_API_TOKEN'),
	    ),
	    'languages' => $this->context->controller->getLanguages(),
	    'id_language' => $this->context->language->id
	);

	return $helper->generateForm($fields_form);
    }

    public function generateToken() {
	return bin2hex(random_bytes(256)); // Генеруємо 256-бітний токен доступу
    }
}
